#!/usr/bin/python
# -*- coding: utf-8 -*-
#QuickSelect
#cet utilitaire permet de choisir facilement les images et de les renommer sur une nouvelle séquence.
#auteur : JB BUTET
#Juillet 2007
#ce code est en GPL v2

try : 
    import pygtk
except : 
    print "vous devez installer pygtk >2.0"

pygtk.require('2.0')
import time
import gtk, os, string

try : 
    import Image
    import ImageDraw
    import ImageOps
except :
    print """"vous devez installer le paquet "PIL", Python Imaging Library souvent nommée "python -imaging" """
import commands
import math
import threading, gobject
try : 
    from kiwi.ui.delegates import Delegate
except : 
    print "vous devez installer Python-kiwi"
    
class quickselect(Delegate): 
    widgets =["imageRef2", "imageEnCours", "filechooserbutton", "seqEntree", "seqSortie", "BoutonAccept", "BoutonRef", "BoutonArriere", "BoutonSuivant", "numeroRef", "numeroActuel", "reference", "progressbar1"]
    gladefile = "quickselect"
    
    def __init__(self):
        Delegate.__init__(self, delete_handler=self.quit_if_last)
        
        self.nomDeSortie = "choice"
        
    def detectSerie(self, image):
        """a partir du nom de fichier, récupère le nom de la série. """
        print image
        self.repertoireDeTravail = '/'.join(image.split('/')[:-1])
        os.chdir(self.repertoireDeTravail)
        #DEBUG print"fichier", image
        racine = '.'.join(image.split('.')[:-1]).rstrip(string.digits).split('/')[-1]
        self.suffixe_image = image.split('.')[-1]
        print self.suffixe_image
        #DEBUG : print"racine", racine
        liste_fichier = os.listdir('.')
        #DEBUG  : print "liste", liste_fichier
        liste_image = []
        liste_finale = []
        
        #sélectionne les fichiers ayant la bonne extension
        for i in liste_fichier : 
            if i.split('.')[-1] == self.suffixe_image:
                liste_image.append(i)

        #sélectionne alors les fichiers ayant la bonne racine
        for i in liste_image :
            #print i
            a =  '.'.join(i.split('.')[:-1]).rstrip(string.digits)
            if a == racine :
                liste_finale.append(i)
        #print liste_finale
        self.suffixe_image_depart = self.suffixe_image
        self.liste_fichier, self.debut, self.fin, self.racineFichier = liste_finale, "1", len(liste_finale), racine
        
        

    def on_filechooserbutton__selection_changed(self,*args):
        """Si l'image est changée, on l'affiche"""
        imageDeLaSerie = self.filechooserbutton.get_filename()
        if imageDeLaSerie.split('.')[-1] == "bmp" or imageDeLaSerie.split('.')[-1] == "jpg" or imageDeLaSerie.split('.')[-1] == "png" or imageDeLaSerie.split('.')[-1] == "jpeg" or imageDeLaSerie.split('.')[-1] == "JPG" :
            
            self.detectSerie(imageDeLaSerie)
            self.seqEntree.set_text(self.racineFichier)
            os.chdir(self.repertoireDeTravail)
            self.numeroDeFichier = 1 #numero du fichier d'entrée
            self.numeroDeFichierSortie = 1 #numero du fichier de sortie
            self.imageEnCours.set_from_file(self.racineFichier+"1."+self.suffixe_image)
            image = Image.open(self.racineFichier+str(self.numeroDeFichier)+"."+self.suffixe_image)
            imagenb = ImageOps.grayscale(image)
            self.entropy = self.calculEntropy(imagenb)
            self.updateLabels("actuelle")
            
        elif imageDeLaSerie.split('.')[-1] == "fit" :  #l'image FIT nécessite de la convretir pour pouvoir  etre affichée.
        
            self.detectSerie(imageDeLaSerie)
            self.seqEntree.set_text(self.racineFichier)
            os.chdir(self.repertoireDeTravail)
            self.numeroDeFichier = 1 #numero du fichier d'entrée
            self.numeroDeFichierSortie = 1 #numero du fichier de sortie
            print "convert -combine "+self.racineFichier+"1."+"fit "+self.racineFichier+"1."+"png"
            status, output = commands.getstatusoutput("convert -combine "+self.racineFichier+"1."+"fit "+self.racineFichier+"1."+"png")  #conversion du FITS 3couches couleur en un png
            
            self.imageEnCours.set_from_file(self.racineFichier+"1."+"png")
            image = Image.open(self.racineFichier+"1."+"png")
            imagenb = ImageOps.grayscale(image)
            self.entropy = self.calculEntropy(imagenb)
            self.updateLabels("actuelle")
        
    
    def sauvImage(self, numeroDeFichierSortie):
        """sauvegarde l'image acceptée avec son nouveau nom"""
        print "cp -f "+self.racineFichier+str(self.numeroDeFichier)+"."+self.suffixe_image_depart +' '+ self.nomDeSortie+str(self.numeroDeFichierSortie)+"."+self.suffixe_image_depart
        
        status, output = commands.getstatusoutput("cp -f "+self.racineFichier+str(self.numeroDeFichier)+"."+self.suffixe_image_depart +' '+ self.nomDeSortie+str(self.numeroDeFichierSortie)+"."+self.suffixe_image_depart )
    
    def MetAJourBarreDeProgession(self, fraction):
        """récupère la fraction et met à jour la barre de progression pregressbar1"""
        self.progressbar1.set_fraction(fraction)
    
    def on_BoutonAccept__clicked(self, *args):
        self.nomdEntree = self.seqEntree.get_text()

        self.nomDeSortie = self.seqSortie.get_text().replace(" ", "_")
        if self.nomDeSortie == "Séquence_de_sortie" :
            self.nomDeSortie = "quickselect"
            
        self.sauvImage(self.numeroDeFichierSortie)
        self.numeroDeFichier += 1
        self.numeroDeFichierSortie += 1
        
        assert(self.suffixe_image_depart == "fit")
        
        if self.suffixe_image_depart == "fit" : #si on a du fit, on le converti en png"
            print "convert -combine "+self.racineFichier+str(self.numeroDeFichier)+".fit "+self.racineFichier+str(self.numeroDeFichier)+".png"
            
            status, output = commands.getstatusoutput("convert -combine "+self.racineFichier+str(self.numeroDeFichier)+".fit "+self.racineFichier+str(self.numeroDeFichier)+".png")
            self.suffixe_image = "png"
            print output
            time.sleep(0.5)
            
        self.imageEnCours.set_from_file(self.racineFichier+str(self.numeroDeFichier)+"."+self.suffixe_image)
        image = Image.open(self.racineFichier+str(self.numeroDeFichier)+"."+self.suffixe_image)
        imagenb = ImageOps.grayscale(image)
        self.entropy = self.calculEntropy(imagenb)
        self.updateLabels("actuelle")
        self.MetAJourBarreDeProgession(float(self.numeroDeFichier/(self.fin+0.0)))
        
##    def on_BoutonAnnule__clicked(self, *args):
##        self.nomdEntree = self.seqEntree.get_text()
##        self.nomDeSortie = self.seqSortie.get_text().replace(" ", "_")
##        #self.sauvImage(self.numeroDeFichierSortie)
##        self.numeroDeFichier += 1
##        #self.numeroDeFichierSortie += 1
##        self.imageEnCours.set_from_file(self.racineFichier+str(self.numeroDeFichier)+suffixe_image)
##        image = Image.open(self.racineFichier+str(self.numeroDeFichier)+suffixe_image)
##        imagenb = ImageOps.grayscale(image)
##        self.entropy = self.calculEntropy(imagenb)
##
##        self.updateLabels("actuelle")
        
    def on_BoutonRef__clicked(self, *args):
        """met l'image actuelle en fond, à gauche"""
        #self.imageRef.set_from_file(self.racineFichier+str(self.numeroDeFichier)+suffixe_image)
        self.imageRef2.set_from_file(self.racineFichier+str(self.numeroDeFichier)+"."+self.suffixe_image)
        self.reference.show()
        
        self.updateLabels("ref")

        self.MetAJourBarreDeProgession(float(self.numeroDeFichier/(self.fin+0.0)))

        #self.reference.show()
        
        
    def updateLabels(self, whichimage):
        "mets à jour les labels sous les images"
        #si which image = ref, on met à jour la ref (gauche) sinon la droite
        if whichimage == "actuelle" :
            self.numeroActuel.set_text(self.racineFichier+str(self.numeroDeFichier)+" entropie = %.5f" % self.entropy)
            
        elif whichimage == "ref" :
                        self.numeroRef.set_text(self.racineFichier+str(self.numeroDeFichier)+" entropie = %.5f" % self.entropy)

        
        
    def on_BoutonArriere__clicked(self, *args):
        """revient à l'image précédente"""
        if self.numeroDeFichier > 1 :
            self.numeroDeFichier  = self.numeroDeFichier - 1
            self.numeroDeFichierSortie =  self.numeroDeFichierSortie - 1
            
            if self.suffixe_image_depart == "fit" : #si on a du fit, on le converti en png"
                status, output = commands.getstatusoutput("convert -combine "+self.racineFichier+str(self.numeroDeFichier)+".fit " +self.racineFichier+str(self.numeroDeFichier)+".png")
                self.suffixe_image = "png"
                time.sleep(0.5)
            
            
            self.imageEnCours.set_from_file(self.racineFichier+str(self.numeroDeFichier)+"."+self.suffixe_image)
            image = Image.open(self.racineFichier+str(self.numeroDeFichier)+"."+self.suffixe_image)
            imagenb = ImageOps.grayscale(image)

            self.entropy = self.calculEntropy(imagenb)

            self.updateLabels("actuelle")
            self.MetAJourBarreDeProgession(float(self.numeroDeFichier/(self.fin+0.0)))

    
    def calculEntropy(self, image):
        """calcul l'entropie de l'image """
        #print "calcul entropie"
        entropy = 0
        histo = image.histogram()
        somme_totale = 0
        for valeur in histo :
            somme_totale = somme_totale + int(valeur)
        
        #print somme_totale
        
        for valeur in histo :
            
            pi = float(valeur)/somme_totale
            
            try : 
                entropy = entropy + pi*math.log(pi)
            except :
                pass
        #calcul de l'entropie
        return entropy
    
    def key_Escape(self, *args):
        "ch'ti essai"
        print "ok c'est bon c amarche"
    
    def on_BoutonSuivant__clicked(self, *args):
        """va à l'image suivante"""
        
        self.numeroDeFichier  = self.numeroDeFichier + 1
        
        if self.suffixe_image_depart == "fit" : #si on a du fit, on le converti en png"
            status, output = commands.getstatusoutput("convert -combine "+self.racineFichier+str(self.numeroDeFichier)+".fit " +self.racineFichier+str(self.numeroDeFichier)+".png")
            self.suffixe_image = "png"
            time.sleep(0.5)
        
        
        self.imageEnCours.set_from_file(self.racineFichier+str(self.numeroDeFichier)+"."+self.suffixe_image)
        image = Image.open(self.racineFichier+str(self.numeroDeFichier)+"."+self.suffixe_image)
        imagenb = ImageOps.grayscale(image)
        self.entropy = self.calculEntropy(imagenb)
        self.MetAJourBarreDeProgession(float(self.numeroDeFichier/(self.fin+0.0)))


        self.updateLabels("actuelle")
        
delegate = quickselect()
delegate.show()
gtk.main()
gtk.destroy()
